/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.29 Revision 1.71
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.29 2005/07/11 15:08:06 swegener Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.71 2009/09/08 12:34:21 robbat2 Exp $
4# 4#
5# Description: This eclass is used as a central eclass for accessing kernel
6# related information for sources already installed.
7# It is vital for linux-mod to function correctly, and is split
8# out so that any ebuild behaviour "templates" are abstracted out
9# using additional eclasses.
10#
11# Maintainer: John Mylchreest <johnm@gentoo.org> 5# Original author: John Mylchreest <johnm@gentoo.org>
12# Copyright 2004 Gentoo Linux 6# Maintainer: kernel-misc@gentoo.org
13# 7#
14# Please direct your bugs to the current eclass maintainer :) 8# Please direct your bugs to the current eclass maintainer :)
9
10# @ECLASS: linux-info.eclass
11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
15 24
16# A Couple of env vars are available to effect usage of this eclass 25# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 26# These are as follows:
18# 27
19# Env Var Option Description 28# @ECLASS-VARIABLE: KERNEL_DIR
20# KERNEL_DIR <string> The directory containing kernel the target kernel 29# @DESCRIPTION:
21# sources. 30# A string containing the directory of the target kernel sources. The default value is
31# "/usr/src/linux"
32
33# @ECLASS-VARIABLE: CONFIG_CHECK
34# @DESCRIPTION:
22# CONFIG_CHECK <string> a list of .config options to check for before 35# A string containing a list of .config options to check for before
23# proceeding with the install. ie: CONFIG_CHECK="MTRR" 36# proceeding with the install.
37#
38# e.g.: CONFIG_CHECK="MTRR"
39#
24# You can also check that an option doesn't exist by 40# You can also check that an option doesn't exist by
25# prepending it with an exclamation mark (!). 41# prepending it with an exclamation mark (!).
42#
26# ie: CONFIG_CHECK="!MTRR" 43# e.g.: CONFIG_CHECK="!MTRR"
27# ERROR_CFG <string> The error message to display when the above check 44#
45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
54
55# @ECLASS-VARIABLE: ERROR_<CFG>
56# @DESCRIPTION:
57# A string containing the error message to display when the check against CONFIG_CHECK
28# fails. <CFG> should reference the appropriate option 58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
29# as above. ie: ERROR_MTRR="MTRR exists in the .config 59#
30# but shouldn't!!" 60# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
31# KBUILD_OUTPUT <string> This is passed on commandline, or can be set from 61
32# the kernel makefile. This contains the directory 62# @ECLASS-VARIABLE: KBUILD_OUTPUT
63# @DESCRIPTION:
64# A string passed on commandline, or set from the kernel makefile. It contains the directory
33# which is to be used as the kernel object directory. 65# which is to be used as the kernel object directory.
34 66
35# There are also a couple of variables which are set by this, and shouldn't be 67# There are also a couple of variables which are set by this, and shouldn't be
36# set by hand. These are as follows: 68# set by hand. These are as follows:
37# 69
38# Env Var Option Description 70# @ECLASS-VARIABLE: KV_FULL
39# KV_FULL <string> The full kernel version. ie: 2.6.9-gentoo-johnm-r1 71# @DESCRIPTION:
40# KV_MAJOR <integer> The kernel major version. ie: 2 72# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
41# KV_MINOR <integer> The kernel minor version. ie: 6 73
42# KV_PATCH <integer> The kernel patch version. ie: 9 74# @ECLASS-VARIABLE: KV_MAJOR
43# KV_EXTRA <string> The kernel EXTRAVERSION. ie: -gentoo 75# @DESCRIPTION:
44# KV_LOCAL <string> The kernel LOCALVERSION concatenation. ie: -johnm 76# A read-only variable. It's an integer containing the kernel major version. ie: 2
45# KV_DIR <string> The kernel source directory, will be null if 77
78# @ECLASS-VARIABLE: KV_MINOR
79# @DESCRIPTION:
80# A read-only variable. It's an integer containing the kernel minor version. ie: 6
81
82# @ECLASS-VARIABLE: KV_PATCH
83# @DESCRIPTION:
84# A read-only variable. It's an integer containing the kernel patch version. ie: 9
85
86# @ECLASS-VARIABLE: KV_EXTRA
87# @DESCRIPTION:
88# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
89
90# @ECLASS-VARIABLE: KV_LOCAL
91# @DESCRIPTION:
92# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
93
94# @ECLASS-VARIABLE: KV_DIR
95# @DESCRIPTION:
96# A read-only variable. It's a string containing the kernel source directory, will be null if
46# KERNEL_DIR is invalid. 97# KERNEL_DIR is invalid.
47# KV_OUT_DIR <string> The kernel object directory. will be KV_DIR unless 98
48# koutput is used. This should be used for referencing 99# @ECLASS-VARIABLE: KV_OUT_DIR
49# .config. 100# @DESCRIPTION:
101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# @ECLASS-VARIABLE: I_KNOW_WHAT_I_AM_DOING
105# @DESCRIPTION:
106# Temporary variable for the migration to making linux-info non-fatal.
50 107
51# And to ensure all the weirdness with crosscompile 108# And to ensure all the weirdness with crosscompile
52inherit toolchain-funcs versionator 109inherit toolchain-funcs versionator
53 110
54EXPORT_FUNCTIONS pkg_setup 111EXPORT_FUNCTIONS pkg_setup
112
113DEPEND=""
114RDEPEND=""
115
116[ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && \
117DEPEND="kernel_linux? ( virtual/linux-sources )"
55 118
56# Overwritable environment Var's 119# Overwritable environment Var's
57# --------------------------------------- 120# ---------------------------------------
58KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}" 121KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
59 122
63case ${ARCH} in 126case ${ARCH} in
64 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 127 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
65 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";; 128 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
66esac 129esac
67 130
68# These are legacy wrappers for toolchain-funcs. 131# @FUNCTION: set_arch_to_kernel
69# I dont like them here, but oh well. 132# @DESCRIPTION:
133# Set the env ARCH to match what the kernel expects.
70set_arch_to_kernel() { export ARCH="$(tc-arch-kernel)"; } 134set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
135# @FUNCTION: set_arch_to_portage
136# @DESCRIPTION:
137# Set the env ARCH to match what portage expects.
71set_arch_to_portage() { export ARCH="$(tc-arch)"; } 138set_arch_to_portage() { export ARCH=$(tc-arch); }
72 139
73# qeinfo "Message" 140# qeinfo "Message"
74# ------------------- 141# -------------------
75# qeinfo is a quiet einfo call when EBUILD_PHASE 142# qeinfo is a quiet einfo call when EBUILD_PHASE
76# should not have visible output. 143# should not have visible output.
91qeerror() { qout eerror "${@}" ; } 158qeerror() { qout eerror "${@}" ; }
92 159
93# File Functions 160# File Functions
94# --------------------------------------- 161# ---------------------------------------
95 162
96# getfilevar accepts 2 vars as follows: 163# @FUNCTION: getfilevar
97# getfilevar <VARIABLE> <CONFIGFILE> 164# @USAGE: variable configfile
98 165# @RETURN: the value of the variable
166# @DESCRIPTION:
167# It detects the value of the variable defined in the file configfile. This is
168# done by including the configfile, and printing the variable with Make.
169# It WILL break if your makefile has missing dependencies!
99getfilevar() { 170getfilevar() {
100local ERROR workingdir basefname basedname myARCH="${ARCH}" 171local ERROR basefname basedname myARCH="${ARCH}"
101 ERROR=0 172 ERROR=0
102 173
103 [ -z "${1}" ] && ERROR=1 174 [ -z "${1}" ] && ERROR=1
104 [ ! -f "${2}" ] && ERROR=1 175 [ ! -f "${2}" ] && ERROR=1
105 176
107 then 178 then
108 echo -e "\n" 179 echo -e "\n"
109 eerror "getfilevar requires 2 variables, with the second a valid file." 180 eerror "getfilevar requires 2 variables, with the second a valid file."
110 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 181 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
111 else 182 else
112 workingdir=${PWD}
113 basefname=$(basename ${2}) 183 basefname="$(basename ${2})"
114 basedname=$(dirname ${2}) 184 basedname="$(dirname ${2})"
115 unset ARCH 185 unset ARCH
116 186
117 cd ${basedname} 187 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
118 echo -e "include ${basefname}\ne:\n\t@echo \$(${1})" | \ 188 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
119 make ${BUILD_FIXES} -s -f - e 2>/dev/null
120 cd ${workingdir}
121 189
122 ARCH=${myARCH} 190 ARCH=${myARCH}
123 fi 191 fi
124} 192}
125 193
194# @FUNCTION: getfilevar_noexec
195# @USAGE: variable configfile
196# @RETURN: the value of the variable
197# @DESCRIPTION:
198# It detects the value of the variable defined in the file configfile.
199# This is done with sed matching an expression only. If the variable is defined,
200# you will run into problems. See getfilevar for those cases.
201getfilevar_noexec() {
202 local ERROR basefname basedname mycat myARCH="${ARCH}"
203 ERROR=0
204 mycat='cat'
205
206 [ -z "${1}" ] && ERROR=1
207 [ ! -f "${2}" ] && ERROR=1
208 [ "${2%.gz}" != "${2}" ] && mycat='zcat'
209
210 if [ "${ERROR}" = 1 ]
211 then
212 echo -e "\n"
213 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
214 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
215 else
216 ${mycat} "${2}" | \
217 sed -n \
218 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
219 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
220 s,[[:space:]]*\$,,g ;
221 p
222 }"
223 fi
224}
225
226
227# @FUNCTION: linux_config_src_exists
228# @RETURN: true or false
229# @DESCRIPTION:
230# It returns true if .config exists in a build directory otherwise false
231linux_config_src_exists() {
232 [ -s "${KV_OUT_DIR}/.config" ]
233}
234
235# @FUNCTION: linux_config_bin_exists
236# @RETURN: true or false
237# @DESCRIPTION:
238# It returns true if .config exists in /proc, otherwise false
239linux_config_bin_exists() {
240 [ -s "/proc/config.gz" ]
241}
242
243# @FUNCTION: linux_config_exists
244# @RETURN: true or false
245# @DESCRIPTION:
246# It returns true if .config exists otherwise false
247#
248# This function MUST be checked before using any of the linux_chkconfig_*
249# functions.
250linux_config_exists() {
251 linux_config_src_exists || linux_config_bin_exists
252}
253
254# @FUNCTION: require_configured_kernel
255# @DESCRIPTION:
256# This function verifies that the current kernel is configured (it checks against the existence of .config)
257# otherwise it dies.
258require_configured_kernel() {
259 if ! linux_config_src_exists; then
260 qeerror "Could not find a usable .config in the kernel source directory."
261 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
262 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
263 qeerror "it points to the necessary object directory so that it might find .config."
264 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
265 fi
266}
267
268# @FUNCTION: linux_chkconfig_present
269# @USAGE: option
270# @RETURN: true or false
271# @DESCRIPTION:
272# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
273# If linux_config_exists returns false, the results of this are UNDEFINED. You
274# MUST call linux_config_exists first.
126linux_chkconfig_present() { 275linux_chkconfig_present() {
127local RESULT 276local RESULT
277 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
278 local config
279 config="${KV_OUT_DIR}/.config"
280 [ ! -f "${config}" ] && config="/proc/config.gz"
128 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 281 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
129 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 282 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
130} 283}
131 284
285# @FUNCTION: linux_chkconfig_module
286# @USAGE: option
287# @RETURN: true or false
288# @DESCRIPTION:
289# It checks that CONFIG_<option>=m is present in the current kernel .config
290# If linux_config_exists returns false, the results of this are UNDEFINED. You
291# MUST call linux_config_exists first.
132linux_chkconfig_module() { 292linux_chkconfig_module() {
133local RESULT 293local RESULT
294 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
295 local config
296 config="${KV_OUT_DIR}/.config"
297 [ ! -f "${config}" ] && config="/proc/config.gz"
134 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 298 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
135 [ "${RESULT}" = "m" ] && return 0 || return 1 299 [ "${RESULT}" = "m" ] && return 0 || return 1
136} 300}
137 301
302# @FUNCTION: linux_chkconfig_builtin
303# @USAGE: option
304# @RETURN: true or false
305# @DESCRIPTION:
306# It checks that CONFIG_<option>=y is present in the current kernel .config
307# If linux_config_exists returns false, the results of this are UNDEFINED. You
308# MUST call linux_config_exists first.
138linux_chkconfig_builtin() { 309linux_chkconfig_builtin() {
139local RESULT 310local RESULT
311 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
312 local config
313 config="${KV_OUT_DIR}/.config"
314 [ ! -f "${config}" ] && config="/proc/config.gz"
140 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 315 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
141 [ "${RESULT}" = "y" ] && return 0 || return 1 316 [ "${RESULT}" = "y" ] && return 0 || return 1
142} 317}
143 318
319# @FUNCTION: linux_chkconfig_string
320# @USAGE: option
321# @RETURN: CONFIG_<option>
322# @DESCRIPTION:
323# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
324# If linux_config_exists returns false, the results of this are UNDEFINED. You
325# MUST call linux_config_exists first.
144linux_chkconfig_string() { 326linux_chkconfig_string() {
327 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
328 local config
329 config="${KV_OUT_DIR}/.config"
330 [ ! -f "${config}" ] && config="/proc/config.gz"
145 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config" 331 getfilevar_noexec "CONFIG_${1}" "${config}"
146} 332}
147 333
148# Versioning Functions 334# Versioning Functions
149# --------------------------------------- 335# ---------------------------------------
150 336
151# kernel_is returns true when the version is the same as the passed version 337# @FUNCTION: kernel_is
338# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
339# @RETURN: true or false
340# @DESCRIPTION:
341# It returns true when the current kernel version satisfies the comparison against the passed version.
342# -eq is the default comparison.
152# 343#
344# @CODE
153# For Example where KV = 2.6.9 345# For Example where KV = 2.6.9
154# kernel_is 2 4 returns false 346# kernel_is 2 4 returns false
155# kernel_is 2 returns true 347# kernel_is 2 returns true
156# kernel_is 2 6 returns true 348# kernel_is 2 6 returns true
157# kernel_is 2 6 8 returns false 349# kernel_is 2 6 8 returns false
158# kernel_is 2 6 9 returns true 350# kernel_is 2 6 9 returns true
159# 351# @CODE
352
160# got the jist yet? 353# got the jist yet?
161 354
162kernel_is() { 355kernel_is() {
163 # if we haven't determined the version yet, we need too. 356 # if we haven't determined the version yet, we need to.
164 get_version; 357 linux-info_get_any_version
358
165 local operator test value x=0 y=0 z=0 359 local operator test value x=0 y=0 z=0
166 360
167 case ${1} in 361 case ${1} in
168 lt) operator="-lt"; shift;; 362 -lt|lt) operator="-lt"; shift;;
169 gt) operator="-gt"; shift;; 363 -gt|gt) operator="-gt"; shift;;
170 le) operator="-le"; shift;; 364 -le|le) operator="-le"; shift;;
171 ge) operator="-ge"; shift;; 365 -ge|ge) operator="-ge"; shift;;
172 eq) operator="-eq"; shift;; 366 -eq|eq) operator="-eq"; shift;;
173 *) operator="-eq";; 367 *) operator="-eq";;
174 esac 368 esac
175 369
176 for x in ${@}; do 370 for x in ${@}; do
177 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done 371 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
178 value="${value}${x}" 372 value="${value}${x}"
186 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done; 380 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
187 test="${test}${KV_PATCH}";; 381 test="${test}${KV_PATCH}";;
188 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 382 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
189 esac 383 esac
190 done 384 done
191 385
192 [ ${test} ${operator} ${value} ] && return 0 || return 1 386 [ ${test} ${operator} ${value} ] && return 0 || return 1
193} 387}
194 388
389get_localversion() {
390 local lv_list i x
391
392 # ignore files with ~ in it.
393 for i in $(ls ${1}/localversion* 2>/dev/null); do
394 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
395 done
396
397 for i in ${lv_list}; do
398 x="${x}$(<${i})"
399 done
400 x=${x/ /}
401 echo ${x}
402}
403
404# internal variable, so we know to only print the warning once
405get_version_warning_done=
406
407# @FUNCTION: get_version
408# @DESCRIPTION:
409# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
410# (if KV_FULL is already set it does nothing).
411#
412# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
413#
414# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
415# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
416# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
195get_version() { 417get_version() {
196 local kbuild_output 418 local kbuild_output
197 419
198 # no need to execute this twice assuming KV_FULL is populated. 420 # no need to execute this twice assuming KV_FULL is populated.
199 # we can force by unsetting KV_FULL 421 # we can force by unsetting KV_FULL
202 # if we dont know KV_FULL, then we need too. 424 # if we dont know KV_FULL, then we need too.
203 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 425 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
204 unset KV_DIR 426 unset KV_DIR
205 427
206 # KV_DIR will contain the full path to the sources directory we should use 428 # KV_DIR will contain the full path to the sources directory we should use
429 [ -z "${get_version_warning_done}" ] && \
207 qeinfo "Determining the location of the kernel source code" 430 qeinfo "Determining the location of the kernel source code"
208 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 431 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
209 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 432 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
210 433
211 if [ -z "${KV_DIR}" ] 434 if [ -z "${KV_DIR}" ]
212 then 435 then
436 if [ -z "${get_version_warning_done}" ]; then
437 get_version_warning_done=1
213 qeerror "Unable to find kernel sources at ${KERNEL_DIR}" 438 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
214 qeinfo "This package requires Linux sources." 439 #qeinfo "This package requires Linux sources."
215 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then 440 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
216 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, " 441 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
217 qeinfo "(or the kernel you wish to build against)." 442 qeinfo "(or the kernel you wish to build against)."
218 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location" 443 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
219 else 444 else
220 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against." 445 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
446 fi
221 fi 447 fi
222 return 1 448 return 1
223 fi 449 fi
224 450
451 if [ -z "${get_version_warning_done}" ]; then
225 qeinfo "Found kernel source directory:" 452 qeinfo "Found kernel source directory:"
226 qeinfo " ${KV_DIR}" 453 qeinfo " ${KV_DIR}"
454 fi
227 455
228 if [ ! -s "${KV_DIR}/Makefile" ] 456 if [ ! -s "${KV_DIR}/Makefile" ]
229 then 457 then
458 if [ -z "${get_version_warning_done}" ]; then
459 get_version_warning_done=1
230 qeerror "Could not find a Makefile in the kernel source directory." 460 qeerror "Could not find a Makefile in the kernel source directory."
231 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources" 461 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
462 fi
232 return 1 463 return 1
233 fi 464 fi
234 465
235 # OK so now we know our sources directory, but they might be using 466 # OK so now we know our sources directory, but they might be using
236 # KBUILD_OUTPUT, and we need this for .config and localversions-* 467 # KBUILD_OUTPUT, and we need this for .config and localversions-*
237 # so we better find it eh? 468 # so we better find it eh?
238 # do we pass KBUILD_OUTPUT on the CLI? 469 # do we pass KBUILD_OUTPUT on the CLI?
239 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}" 470 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
240 471
241 # And if we didn't pass it, we can take a nosey in the Makefile 472 # And if we didn't pass it, we can take a nosey in the Makefile
242 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)" 473 kbuild_output="$(getfilevar_noexec KBUILD_OUTPUT ${KV_DIR}/Makefile)"
243 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}" 474 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
244 475
245 # And contrary to existing functions I feel we shouldn't trust the 476 # And contrary to existing functions I feel we shouldn't trust the
246 # directory name to find version information as this seems insane. 477 # directory name to find version information as this seems insane.
247 # so we parse ${KV_DIR}/Makefile 478 # so we parse ${KV_DIR}/Makefile
248 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 479 KV_MAJOR="$(getfilevar_noexec VERSION ${KV_DIR}/Makefile)"
249 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 480 KV_MINOR="$(getfilevar_noexec PATCHLEVEL ${KV_DIR}/Makefile)"
250 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 481 KV_PATCH="$(getfilevar_noexec SUBLEVEL ${KV_DIR}/Makefile)"
251 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 482 KV_EXTRA="$(getfilevar_noexec EXTRAVERSION ${KV_DIR}/Makefile)"
252 483
253 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ] 484 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
254 then 485 then
486 if [ -z "${get_version_warning_done}" ]; then
487 get_version_warning_done=1
255 qeerror "Could not detect kernel version." 488 qeerror "Could not detect kernel version."
256 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources." 489 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
490 fi
257 return 1 491 return 1
258 fi 492 fi
259 493
260 # and in newer versions we can also pull LOCALVERSION if it is set. 494 # and in newer versions we can also pull LOCALVERSION if it is set.
261 # but before we do this, we need to find if we use a different object directory. 495 # but before we do this, we need to find if we use a different object directory.
262 # This *WILL* break if the user is using localversions, but we assume it was 496 # This *WILL* break if the user is using localversions, but we assume it was
263 # caught before this if they are. 497 # caught before this if they are.
264 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}" == "$(uname -r)" ] && \ 498 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
265 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}.${KV_EXTRA}/build}" 499 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
266 500
267 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})" 501 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
268 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}" 502 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
269 if [ -n "${KV_OUT_DIR}" ]; 503 if [ -n "${KV_OUT_DIR}" ];
270 then 504 then
271 qeinfo "Found kernel object directory:" 505 qeinfo "Found kernel object directory:"
272 qeinfo " ${KV_OUT_DIR}" 506 qeinfo " ${KV_OUT_DIR}"
273 507
274 KV_LOCAL="$(cat ${KV_OUT_DIR}/localversion* 2>/dev/null)" 508 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
275 fi 509 fi
276 # and if we STILL haven't got it, then we better just set it to KV_DIR 510 # and if we STILL have not got it, then we better just set it to KV_DIR
277 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}" 511 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
278 512
279 KV_LOCAL="${KV_LOCAL}$(cat ${KV_DIR}/localversion* 2>/dev/null)" 513 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
514 if linux_config_src_exists; then
280 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)" 515 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
281 KV_LOCAL="${KV_LOCAL//\"/}" 516 KV_LOCAL="${KV_LOCAL//\"/}"
517
518 # For things like git that can append extra stuff:
519 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
520 linux_chkconfig_builtin LOCALVERSION_AUTO &&
521 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
522 fi
282 523
283 # And we should set KV_FULL to the full expanded version 524 # And we should set KV_FULL to the full expanded version
284 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 525 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
285 526
286 qeinfo "Found sources for kernel version:" 527 qeinfo "Found sources for kernel version:"
287 qeinfo " ${KV_FULL}" 528 qeinfo " ${KV_FULL}"
288 529
289 if [ ! -s "${KV_OUT_DIR}/.config" ]
290 then
291 qeerror "Could not find a usable .config in the kernel source directory."
292 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
293 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
294 qeerror "it points to the necessary object directory so that it might find .config."
295 return 1
296 fi
297
298 return 0 530 return 0
299} 531}
300 532
533# @FUNCTION: get_running_version
534# @DESCRIPTION:
535# It gets the version of the current running kernel and the result is the same as get_version() if the
536# function can find the sources.
301get_running_version() { 537get_running_version() {
302 KV_FULL=$(uname -r) 538 KV_FULL=$(uname -r)
303 539
304 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then 540 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
305 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source) 541 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
320 && KV_EXTRA="-${KV_FULL#*-}" 556 && KV_EXTRA="-${KV_FULL#*-}"
321 fi 557 fi
322 return 0 558 return 0
323} 559}
324 560
561# This next function is named with the eclass prefix to avoid conflicts with
562# some old versionator-like eclass functions.
563
564# @FUNCTION: linux-info_get_any_version
565# @DESCRIPTION:
566# This attempts to find the version of the sources, and otherwise falls back to
567# the version of the running kernel.
568linux-info_get_any_version() {
569 get_version
570 if [[ $? -ne 0 ]]; then
571 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
572 get_running_version
573 fi
574}
575
325 576
326# ebuild check functions 577# ebuild check functions
327# --------------------------------------- 578# ---------------------------------------
328 579
580# @FUNCTION: check_kernel_built
581# @DESCRIPTION:
582# This function verifies that the current kernel sources have been already prepared otherwise it dies.
329check_kernel_built() { 583check_kernel_built() {
330 # if we haven't determined the version yet, we need too. 584 # if we haven't determined the version yet, we need to
585 require_configured_kernel
331 get_version; 586 get_version
332 587
333 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ] 588 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
334 then 589 then
335 eerror "These sources have not yet been prepared." 590 eerror "These sources have not yet been prepared."
336 eerror "We cannot build against an unprepared tree." 591 eerror "We cannot build against an unprepared tree."
343 eerror "Then please try merging this module again." 598 eerror "Then please try merging this module again."
344 die "Kernel sources need compiling first" 599 die "Kernel sources need compiling first"
345 fi 600 fi
346} 601}
347 602
603# @FUNCTION: check_modules_supported
604# @DESCRIPTION:
605# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
348check_modules_supported() { 606check_modules_supported() {
349 # if we haven't determined the version yet, we need too. 607 # if we haven't determined the version yet, we need too.
608 require_configured_kernel
350 get_version; 609 get_version
351 610
352 if ! linux_chkconfig_builtin "MODULES" 611 if ! linux_chkconfig_builtin "MODULES"
353 then 612 then
354 eerror "These sources do not support loading external modules." 613 eerror "These sources do not support loading external modules."
355 eerror "to be able to use this module please enable \"Loadable modules support\"" 614 eerror "to be able to use this module please enable \"Loadable modules support\""
356 eerror "in your kernel, recompile and then try merging this module again." 615 eerror "in your kernel, recompile and then try merging this module again."
357 die "No support for external modules in ${KV_FULL} config" 616 die "No support for external modules in ${KV_FULL} config"
358 fi 617 fi
359} 618}
360 619
620# @FUNCTION: check_extra_config
621# @DESCRIPTION:
622# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
623# the prefix ~ is not used) doesn't satisfy the directive.
361check_extra_config() { 624check_extra_config() {
362 local config negate error local_error i n temp_config 625 local config negate die error reworkmodulenames
626 local soft_errors_count=0 hard_errors_count=0 config_required=0
363 627
364 # if we haven't determined the version yet, we need too. 628 # if we haven't determined the version yet, we need to
365 get_version; 629 linux-info_get_any_version
366 630
367 einfo "Checking for suitable kernel configuration options" 631 # Determine if we really need a .config. The only time when we don't need
632 # one is when all of the CONFIG_CHECK options are prefixed with "~".
368 for config in ${CONFIG_CHECK} 633 for config in ${CONFIG_CHECK}
369 do 634 do
370 negate="${config:0:1}" 635 if [[ "${config:0:1}" != "~" ]]; then
371 if [ "${negate}" == "!" ]; 636 config_required=1
372 then 637 break
638 fi
639 done
640
641 if [[ ${config_required} == 0 ]]; then
642 # In the case where we don't require a .config, we can now bail out
643 # if the user has no .config as there is nothing to do. Otherwise
644 # code later will cause a failure due to missing .config.
645 if ! linux_config_exists; then
646 ewarn "Unable to check for the following kernel config options due"
647 ewarn "to absence of any configured kernel sources or compiled"
648 ewarn "config:"
649 for config in ${CONFIG_CHECK}; do
650 ewarn " - ${config#\~}"
651 done
652 ewarn "You're on your own to make sure they are set if needed."
653 return 0
654 fi
655 else
656 [ -n "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
657 fi
658
659 einfo "Checking for suitable kernel configuration options..."
660
661 for config in ${CONFIG_CHECK}
662 do
663 # if we specify any fatal, ensure we honor them
664 die=1
665 error=0
666 negate=0
667 reworkmodulenames=0
668
669 if [[ ${config:0:1} == "~" ]]; then
670 die=0
373 config="${config:1}" 671 config=${config:1}
672 elif [[ ${config:0:1} == "@" ]]; then
673 die=0
674 reworkmodulenames=1
675 config=${config:1}
676 fi
677 if [[ ${config:0:1} == "!" ]]; then
678 negate=1
679 config=${config:1}
680 fi
681
682 if [[ ${negate} == 1 ]]; then
683 linux_chkconfig_present ${config} && error=2
684 elif [[ ${reworkmodulenames} == 1 ]]; then
685 local temp_config="${config//*:}" i n
686 config="${config//:*}"
374 if linux_chkconfig_present ${config} 687 if linux_chkconfig_present ${config}; then
375 then 688 for i in ${MODULE_NAMES}; do
689 n="${i//${temp_config}}"
690 [[ -z ${n//\(*} ]] && \
691 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
692 done
693 error=2
694 fi
695 else
696 linux_chkconfig_present ${config} || error=1
697 fi
698
699 if [[ ${error} > 0 ]]; then
700 local report_func="eerror" local_error
701 local_error="ERROR_${config}"
702 local_error="${!local_error}"
703
704 if [[ -z "${local_error}" ]]; then
705 # using old, deprecated format.
376 local_error="${config}_ERROR" 706 local_error="${config}_ERROR"
377 local_error="${!local_error}" 707 local_error="${!local_error}"
378 [ -n "${local_error}" ] && eerror " ${local_error}" || \
379 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is."
380 error=1
381 fi 708 fi
382 elif [ "${negate}" == "@" ]; 709 if [[ ${die} == 0 && -z "${local_error}" ]]; then
383 then 710 #soft errors can be warnings
384 # we never call this unless we are using MODULE_NAMES
385
386 config="${config:1}"
387 temp_config="${config//*:}"
388 config="${config//:*}"
389 if linux_chkconfig_present ${config}
390 then
391 local_error="${config}_ERROR" 711 local_error="WARNING_${config}"
392 local_error="${!local_error}" 712 local_error="${!local_error}"
393 [ -n "${local_error}" ] && eerror " ${local_error}" || \ 713 if [[ -n "${local_error}" ]] ; then
394 eerror " CONFIG_${config}:\tshould not be set in the kernel configuration, but it is." 714 report_func="ewarn"
395 715 fi
396 for i in ${MODULE_NAMES}
397 do
398 n="${i//${temp_config}}"
399 [ -z "${n//(*}" ] && MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
400 done
401 error=0
402 fi 716 fi
403 else
404 if ! linux_chkconfig_present ${config}
405 then
406 # Support the new syntax first.
407 local_error="ERROR_${config}"
408 local_error="${!local_error}"
409 717
410 # then fall back on the older syntax.
411 if [[ -z ${local_error} ]] ; then 718 if [[ -z "${local_error}" ]]; then
412 local_error="${config}_ERROR" 719 [[ ${error} == 1 ]] \
413 local_error="${!local_error}" 720 && local_error="is not set when it should be." \
414 fi 721 || local_error="should not be set. But it is."
415 722 local_error="CONFIG_${config}:\t ${local_error}"
416 [[ -n ${local_error} ]] && eerror " ${local_error}" || \
417 eerror " CONFIG_${config}:\tshould be set in the kernel configuration, but isn't"
418 error=1
419 fi 723 fi
724 if [[ ${die} == 0 ]]; then
725 ${report_func} " ${local_error}"
726 soft_errors_count=$[soft_errors_count + 1]
727 else
728 ${report_func} " ${local_error}"
729 hard_errors_count=$[hard_errors_count + 1]
730 fi
420 fi 731 fi
421 done 732 done
422 733
423 if [ "${error}" == 1 ] ; 734 if [[ ${hard_errors_count} > 0 ]]; then
424 then
425 eerror "Please check to make sure these options are set correctly." 735 eerror "Please check to make sure these options are set correctly."
736 eerror "Failure to do so may cause unexpected problems."
426 eerror "Once you have satisfied these options, please try merging" 737 eerror "Once you have satisfied these options, please try merging"
427 eerror "this package again." 738 eerror "this package again."
428 die "Incorrect kernel configuration options" 739 die "Incorrect kernel configuration options"
740 elif [[ ${soft_errors_count} > 0 ]]; then
741 ewarn "Please check to make sure these options are set correctly."
742 ewarn "Failure to do so may cause unexpected problems."
743 else
744 eend 0
429 fi 745 fi
430} 746}
431 747
432check_zlibinflate() { 748check_zlibinflate() {
433 # if we haven't determined the version yet, we need too. 749 # if we haven't determined the version yet, we need to
750 require_configured_kernel
434 get_version; 751 get_version
435 752
436 # although I restructured this code - I really really really dont support it! 753 # although I restructured this code - I really really really dont support it!
437 754
438 # bug #27882 - zlib routines are only linked into the kernel 755 # bug #27882 - zlib routines are only linked into the kernel
439 # if something compiled into the kernel calls them 756 # if something compiled into the kernel calls them
446 local DEFLATE 763 local DEFLATE
447 764
448 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 765 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
449 766
450 ebegin "checking ZLIB_INFLATE" 767 ebegin "checking ZLIB_INFLATE"
451 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 768 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
452 eend $? 769 eend $?
453 [ "$?" != 0 ] && die 770 [ "$?" != 0 ] && die
454 771
455 ebegin "checking ZLIB_DEFLATE" 772 ebegin "checking ZLIB_DEFLATE"
456 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 773 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
457 eend $? 774 eend $?
458 [ "$?" != 0 ] && die 775 [ "$?" != 0 ] && die
459 776
460 local LINENO_START 777 local LINENO_START
461 local LINENO_END 778 local LINENO_END
499} 816}
500 817
501################################ 818################################
502# Default pkg_setup 819# Default pkg_setup
503# Also used when inheriting linux-mod to force a get_version call 820# Also used when inheriting linux-mod to force a get_version call
504 821# @FUNCTION: linux-info_pkg_setup
822# @DESCRIPTION:
823# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
824# to support the options specified in CONFIG_CHECK (if not null)
505linux-info_pkg_setup() { 825linux-info_pkg_setup() {
506 get_version || die "Unable to calculate Linux Kernel version" 826 linux-info_get_any_version
827
828 if kernel_is 2 4; then
829 if [ "$( gcc-major-version )" -eq "4" ] ; then
830 echo
831 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
832 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
833 echo
834 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
835 ewarn "newer kernel that supports gcc-4."
836 echo
837 ewarn "Also be aware that bugreports about gcc-4 not working"
838 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
839 echo
840 epause 10
841 fi
842 fi
843
507 [ -n "${CONFIG_CHECK}" ] && check_extra_config; 844 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
508} 845}

Legend:
Removed from v.1.29  
changed lines
  Added in v.1.71

  ViewVC Help
Powered by ViewVC 1.1.20